<?php 
namespace WOO_PRODUCT_TABLE_PRO\Classes;

/**
 * Inlince CSS Generator
 * 
 * from Design tab of Each Product Table
 * 
 * @author Saiful Islam <codersaiful@gmail.com>
 * @author Fazle bari <fazlebarisn@gmail.com>
 * 
 * @since 8.0.8.1
 */
class Inline_Css_Generator{

    public $ID;
    public $temp_number;
    public static $temp_numbersss;

    public $transient = 'wpt_css_transient';

    public $css_output = null;
    public $disabled_css_gen = [
        // 'tr.wpt_table_head th' //etate somossa hobe, onekgulo aitem disable hoye jacche. notun somadhan ber korte hobe
    ];
    
    public $disabled_table_id = [
        'div.wpt_notice_board div.woocommerce-message',
    ];

    /**
     * Action Hook: wpto_action_after_table 
     *
     * @return void
     */

     public function __construct()
     {
        
        add_action('wpto_action_after_table' , [$this, 'wpto_action_inject_styles']);
        add_action('wpto_on_save_post' , [$this, 'delete_transient']);
     }

     /**
      * Transient will be delete based on $table_id
      * Actually when table will be save or update, css's transient will be destroy
      *
      * @param int|mixed $table_id
      * @return void
      */
     public function delete_transient( $table_id )
     {
        
        $transient_key = $this->transient . '_' . $table_id;
        delete_transient($transient_key);
        return;
     }

     /**
      * Generate style css when save some changed on Design tab.
      *
      * @param mixed $table_ID
      * @return void
      */
     public function wpto_action_inject_styles( $table_ID ){
        
        $ID = $temp_number = $table_ID;
        $this->temp_number = $this->ID = $table_ID;

        $transient_key = $this->transient . '_' . $table_ID;
        $css_value = get_transient($transient_key);

        if( ! empty( $css_value ) ){
            echo $css_value;
            return;
        }

        $table_style = get_post_meta( $ID, 'table_style', true );
        if(isset($table_style['tr.wpt_table_head th']['auto-responsive-column-label'])){
            unset($table_style['tr.wpt_table_head th']['auto-responsive-column-label']);
        }
        
        $custom_css_code = '';
        if( is_array($table_style) ){

            $custom_style = $table_style;
            unset($custom_style['template']);
            $custom_css_code .= "<style>\n";
            $this->css_output .= "<style>\n";
            foreach($custom_style as $selector=>$properties){
                if( in_array($selector, $this->disabled_css_gen) ) continue; //No need CSS gen for this selector

                $custom_css_code .= $this->property_to_style($selector, $properties);
                $this->css_output .= $this->property_to_style($selector, $properties);
                
            }
            $custom_css_code .= "\n</style>";
            $this->css_output .= "\n</style>";
        }

        //Set or add to css value to transient for 10 days
        set_transient($transient_key, $this->css_output, 86400 * 10 );

        echo $this->css_output;//$custom_css_code;
     }

    public function property_to_style($selector, $properties){
            $custom_css_code = '';
            $selector = str_replace('{', '[', $selector); 
            $selector = str_replace('}', ']', $selector);  
            $selector = str_replace('%', '+', $selector); 
            
            $my_selector = '.wpt_id_'.$this->temp_number . ' ' . $selector;
            if( in_array($selector, $this->disabled_table_id) ){
                $my_selector = $selector;
            }
            
            $full_selector = $my_selector .'{';
            
            $full_selector = str_replace( ',', ',.wpt_id_'.$this->temp_number . ' ', $full_selector );
            $custom_css_code .= $full_selector;
            foreach( $properties as $property=>$value ){
                $custom_css_code .= !empty( $value ) ? $property . ': ' . $value . " !important;" : '';
            }
            $custom_css_code .= "} \n";
            return $custom_css_code;
    }
    
}

new Inline_Css_Generator();